## python version
## In this script we determine the number of alleles unique to each species.

import pandas as pd

shock = pd.read_csv('shock.str', delim_whitespace=True, header=None, na_values='-9')
sord = pd.read_csv('sored.str', delim_whitespace=True, header=None, na_values='-9')

# Make a copy and create a nunique row
sshock = shock.copy()
sshock.loc['nunique'] = sshock.iloc[:,1:].nunique(axis=0)

# Make a copy and create a nunique row
ssord = sord.copy()
ssord.loc['nunique'] = ssord.iloc[:, 1:].nunique(axis=0)

shock_avg = sshock.loc['nunique'].mean()
print(shock_avg)

sord_avg = ssord.loc['nunique'].mean()
print(sord_avg)

# To get around the NaN, I am just forward filling.
shocky = shock.iloc[:,1:].fillna(method='ffill')
shocky_list = []
for col in shocky:
    shocky_list.append(list(shocky[col].unique().astype(int)))
print(len(shocky_list))

# printing first 5 elements of list to make sure looks correct
print(shocky_list[:5])

sordy = sord.iloc[:,1:].fillna(method='ffill')
sordy_list = []
for col in sordy:
    sordy_list.append(list(sordy[col].unique().astype(int)))
print(len(sordy_list))

# loop for each element in list (we have a list of lists)
print(len(sordy_list))
unique_sordy = []
count = 0
for i in range(0,len(sordy_list)):
    to_add = list(set(sordy_list[i]) - set(shocky_list[i]))
    unique_sordy.append(to_add)
    count = count + len(to_add)
print('Number of alleles unique to soredium is {}.'.format(count))

# Now for shockleyi
print(len(shocky_list))
#unique_sordy = [[] for i in range(len(sordy_list))]
#print(len(unique_sordy))
unique_shocky = []
count = 0
for i in range(0,len(shocky_list)):
    to_add = list(set(shocky_list[i]) - set(sordy_list[i]))
    unique_shocky.append(to_add)
    count = count + len(to_add)
print('Number of alleles unique to shockleyi is {}.'.format(count))
